"{ Package: 'jv:libgdbs' }"

GDBMICommand subclass:#GDBMI_catch_load
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core-Commands-MI'
!

!GDBMI_catch_load class methodsFor:'documentation'!

documentation
"
The `-catch-load' Command
-------------------------

Synopsis
........

      -catch-load [ -t ] [ -d ] REGEXP

   Add a catchpoint for library load events.  If the `-t' option is
used, the catchpoint is a temporary one (*note Setting Breakpoints: Set
Breaks.).  If the `-d' option is used, the catchpoint is created in a
disabled state.  The `regexp' argument is a regular expression used to
match the name of the loaded library.

{No value for `GDBN'} Command
.............................

The corresponding {No value for `GDBN'} command is `catch load'.

Example
.......

     -catch-load -t foo.so
     ^done,bkpt={number='1',type='catchpoint',disp='del',enabled='y',
     what='load of library matching foo.so',catch-type='load',times='0'}
     (gdb)


"
! !

!GDBMI_catch_load methodsFor:'accessing'!

operation
	^ 'catch-load'
! !

