"{ Package: 'jv:libgdbs' }"

GDBMICommand subclass:#GDBMI_data_write_memory_bytes
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core-Commands-MI'
!

!GDBMI_data_write_memory_bytes class methodsFor:'documentation'!

documentation
"
The `-data-write-memory-bytes' Command
--------------------------------------

Synopsis
........

      -data-write-memory-bytes ADDRESS CONTENTS
      -data-write-memory-bytes ADDRESS CONTENTS [COUNT]

where:

`ADDRESS'
     An expression specifying the address of the first memory word to be
     read.  Complex expressions containing embedded white space should
     be quoted using the C convention.

`CONTENTS'
     The hex-encoded bytes to write.

`COUNT'
     Optional argument indicating the number of bytes to be written.
     If COUNT is greater than CONTENTS' length, {No value for `GDBN'}
     will repeatedly write CONTENTS until it fills COUNT bytes.


{No value for `GDBN'} Command
.............................

There's no corresponding {No value for `GDBN'} command.

Example
.......

     (gdb)
     -data-write-memory-bytes &a 'aabbccdd'
     ^done
     (gdb)

     (gdb)
     -data-write-memory-bytes &a 'aabbccdd' 16e
     ^done
     (gdb)


"
! !

!GDBMI_data_write_memory_bytes methodsFor:'accessing'!

operation
	^ 'data-write-memory-bytes'
! !

